> For the complete documentation index, see [llms.txt](https://docs.defisaver.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.defisaver.com/actions/morphoblue/morphobluepayback.md).

# MorphoBluePayback

### Description

Payback a token to Morpho Blue market

### Action ID

`0xca8b1df9`

### SDK Action

```ts
const morphoBluePaybackAction = new dfs.actions.morpho-blue.MorphoBluePaybackAction(
    loanToken,
    collateralToken,
    oracle,
    irm,
    lltv,
    paybackAmount,
    from,
    onBehalf
);
```

### Action Type

`STANDARD_ACTION`

### Input Parameters

```solidity
    /// @param marketParams Market params of specified Morpho Blue market
    /// @param paybackAmount The amount of tokens to payback (uint.max for full debt repayment)
    /// @param from The Address from which to pull tokens to be repaid
    /// @param onBehalf The address that will have its debt reduced
    struct Params {
        MarketParams marketParams;
        uint256 paybackAmount;
        address from;
        address onBehalf;
    }
```

### Return Value

```solidity
return bytes32(amount);
```

### Events and Logs

```solidity
emit ActionEvent("MorphoBluePayback", logData);
logger.logActionDirectEvent("MorphoBluePayback", logData);
bytes memory logData = abi.encode(params);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.defisaver.com/actions/morphoblue/morphobluepayback.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
